import Bladex
import Breakings
import Sparks
import Reference
import CharStats
import ItemTypes

PJ_DEF = [  2,  9,  14,  19 ]
PJ_ATT = [  2,  9,  14,  19 ]

PJ_CFG ={
	  "Knight_N":	[ ### C A B A L L E R O ###
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo2",
	  				),
	  				(### ESPADAS ###
	  					"Gladius",
	  					"Maza",
	  					"Espadaromana",
	  				),### Life ###
	  				300,
	  				# Energy 540
	  				540, 
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo9",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Espadaelfica",
	  					"Maza2",
	  					"HookSword",
	  				),### Life ###
	  				2200,
	  				# Energy 1210
	  				1210, 
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"Escudo3",
	  					"KingShield",
	  				),
	  				(### ESPADAS ###
	  					"Cimitarra",
	  					"Dagesse",
	  					"Maza3",
	  				),### Life ###
	  				4600,
	  				# Energy 3800
	  				3800, 
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo6",
						"KingShield",
	  				),
	  				(### ESPADAS ###
	  					"Espada",
	  					"Espadafilo",
	  					"IceSword",
	  				),### Life ###
	  				6200,
	  				# Energy 8600
	  				8600, 
	  			),
	  		],
	  "Barbarian_N":	[ ### B A R B A R O ###
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo2",
	  				),
	  				(### ESPADAS ###
	  					"Chaosword",
	  					"Eclipse",
	  					"DeathSword",
	  				),### Life ###
	  				300,
	  				# Energy 540
	  				610, 
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo9",
	  				),
	  				(### ESPADAS ###
	  					"Guadanya",
	  					"LongSword",
	  					"Alfanje",
	  				),### Life ###
	  				2200,
	  				# Energy 1210
	  				1360, 
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"KingShield",
	  					"Escudo3",
	  				),
	  				(### ESPADAS ###
	  					"Hacha2hojas",
	  					"IceAxe",
						"FlatSword",
	  					"BigSword",
	  				),### Life ###
	  				4600,
	  				# Energy 3800
	  				4400, 
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo6",
	  				),
	  				(### ESPADAS ###
	  					"RhinoClub",
	  					"Hacharrajada",
	  					"SawSword",
	  					"IceAxe",
	  				),### Life ###
	  				6200,
	  				# Energy 8600
	  				9100, 
	  			),
	  		],
	  "Dwarf_N":	[ ### E N A N O ###	  
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo2",
	  				),
	  				(### ESPADAS ###
	  					"Hacha",
	  					"Hacha5",
	  					"Garropin",
	  				),### Life ###
	  				300,
	  				# Energy
	  				540, 
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo9",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Martillo",
	  					"Hacha3",
	  					"QueenSword",
	  				),### Life ###
	  				2200,
	  				# Energy
	  				1650, 
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"Escudo3",
	  					"KingShield",
	  				),
	  				(### ESPADAS ###
	  					"IceHammer",
	  					"Garrote2",
	  					"MazaDoble",
	  				),### Life ###
	  				4600,
	  				# Energy
	  				3800, 
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
						"Escudo6",
						"Escudo6",
	  				),
	  				(### ESPADAS ###
	  					"IceHammer",
	  					"Martillo3",
	  					"Hacha6",
	  				),### Life ###
	  				6200,
	  				# Energy
	  				8600, 
	  			),
	  		],
	  "Amazon_N":	[ ### A M A Z O N A ### 
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo2",
	  				),
	  				(### ESPADAS ###
	  					"Bo",
	  					"Bichero",
	  					"Lanza",
	  				),### Life ###
	  				300,
	  				# Energy
	  				540, 
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  					"Escudo9",
	  				),
	  				(### ESPADAS ###
	  					"Naginata",
	  					"Tridente",
	  					"Axpear",
	  				),### Life ###
	  				2200,
	  				# Energy
	  				1210, 
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"KingShield",
	  					"Escudo3",
	  				),
	  				(### ESPADAS ###
	  					"CrushBo",
	  					"Crosspear",
	  					"Hachacuchilla",
	  					"IceWand",
	  				),### Life ###
	  				4600,
	  				# Energy
	  				3800, 
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo6",
	  				),
	  				(### ESPADAS ###
	  					"Naginata2",
	  					"LanzaAncha",
	  					"SteelFeather",
	  				),### Life ###
	  				6200,
	  				# Energy
	  				8600, 
	  			),
	  		],
	}

	
def AddStandardWeapons2Char(EntityName,Typo="Knight",Handicap=4):

	ent = Bladex.GetEntity(EntityName)
	INV = ent.GetInventory()
	
	Weapons = PJ_CFG[Typo][Handicap-1][1]

	First = 1
	ent.Data.NetWeapons = []
	for arma in Weapons:
		sword=Bladex.CreateEntity("xxx"+Bladex.GenerateEntityName(),arma,0,0,0)
		print arma
		swordName = sword.Name
		sword.Weapon=1
		ItemTypes.ItemDefaultFuncs(sword)
		Breakings.SetBreakableWS(swordName)
		flag=Reference.GiveWeaponFlag(swordName)
		INV.AddWeapon(swordName,flag)
		ent.Data.NetWeapons.append(swordName)
		if First:
			INV.LinkRightHand(swordName)
			First = 0

	ent.Level         = 19
	ent.Life          = PJ_CFG[Typo][Handicap-1][2]
	ent.Data.NetLevel = Handicap
	ent.Data.NetLife  = ent.Life
	### Trying to import the additional module
	try:
		import NetAddOn
		print "NetAddOn - module is imported"
		NetAddOn.ChangeData()
		NetAddOn.ChangeCombos()
		NetAddOn.ChangeAnmFact()
		NetAddOn.ChangeDamage()
	except:
		print "NetAddOn - module is NOT found"

def AddStandardShields2Char(EntityName,Typo="Knight",Handicap=4):

	ent = Bladex.GetEntity(EntityName)
	INV = ent.GetInventory()
	
	Shields = PJ_CFG[Typo][Handicap-1][0]
	Weapons = PJ_CFG[Typo][Handicap-1][1]

	First = 1
	for arma in Shields:
		# Escudo redondo
		shield=Bladex.CreateEntity("xxx"+Bladex.GenerateEntityName(),arma,0,0,0)
		print arma
		shieldname = shield.Name
		Sparks.MakeShield(shieldname)
		Breakings.SetBreakableWS(shieldname)
		INV.AddShield(shieldname)
		ent.Data.NetWeapons.append(shieldname)
		if First:
			First = 0
			if Reference.DefaultObjectData[Weapons[0]][5][0] == Reference.W_FLAG_1H:
				INV.LinkLeftHand(shieldname)
			
			

def GetDefense(Typo,Handicap):
	return CharStats.GetCharDefenseData(Typo,PJ_DEF[Handicap-1])

def GetDamage(Typo,Handicap):
	return CharStats.GetCharDamageData(Typo,PJ_ATT[Handicap-1])

def GetEnergy(pers):
	try:
		return PJ_CFG[pers.Kind][pers.Data.NetLevel-1][3]
		
	except:
		return 14
